;;
;; Copyright (c) 2016 Marco Granati <mg@unet.bz>
;;
;; Permission to use, copy, modify, and distribute this software for any
;; purpose with or without fee is hereby granted, provided that the above
;; copyright notice and this permission notice appear in all copies.
;;
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
;; WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
;; MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
;; ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
;; ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
;; OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

;; name: dirp05.inc	
;; rev.: 2017/07/04
;; bios C816 version v1.0

.LIST on

SOBUFADDR3	.EQU	SPOUTBUFF3
SIBUFADDR3	.EQU	SPINBUFF3
SOBUFSIZ3	.EQU	$1000
SIBUFSIZ3	.EQU	$1000

SOBUFADDR4	.EQU	SPOUTBUFF4
SIBUFADDR4	.EQU	SPINBUFF4
;SOBUFSIZ4	.EQU	$1000
;SIBUFSIZ4	.EQU	$1000
SOBUFSIZ4	.EQU	$8000
SIBUFSIZ4	.EQU	$8000

NGUARD31	.EQU	$0200	; numero bytes di guardia buffer RX XON/XOFF
NGUARD32	.EQU	$0100	; numero bytes di guardia buffer RX handshake
NFREE31		.EQU	$0800	; minimo posto in coda RX per cancellare pausa remota
NFREE32		.EQU	$0400

;---------------------------------------------------------------------------
; direct page var's for test serial ports/usb handling 
;---------------------------------------------------------------------------

DPSP2:	.SECTION page0, common, ref_only	;UART D.P.

usbslv		.DB	; <7>: plugged-in, <6>: plug-in pending 
usbum		.DB	; <7>: pending message, <6>: connected	
usbcnt1		.DB	; timeout UM245 plug-in detection
usbbuf		.DS	8	
usbtim		.DB
usbcnt		.DB
usbmst		.DB
usbsiz		.DW
usbptr		LP
usbtmp		.DB
usbcmp		.DB

; serial port 65C51
spmode3		.DB	; <7>: 0=no handshake, 1=handshake
			; <6>: 0=software/1=hardware handshake
			; <5>: not used
			; <4>: not used
			; <3>: 0=odd parity, 1=even parity
			; <2>: 0=no parity, 1=parity as specified
			;      by bit <3>
			; <1:0> : baud rate
			;	00 =  19200
			;	01 =  38400
			;	10 =  57600
			;	11 = 115200
			
splin3		.DB	; <7>: /CTS line level
			; <6>: /DSR line status
			
sppause3	.DB
spout3		.DB
spstat3		.DB	; staus
			; <7>: rx error (data discarded)
			; <6>: rx buffer overflow
			; <5>: remote disconnession (/DSR line = 1)
			; <4>: output buffer overflow
			; <3>: not used
			; <2>: framing error
			; <1>: parity error
			; <0>: overrun error

sptmp3		.DB

ibuftail3	.DW
ibufhead3	.DW
obuftail3	.DW
obufhead3	.DW
ibufcnt3	.DW
obufcnt3	.DW
icntmin3	.DW
icntmax3	.DW

; serial port 16C550
spmode4		.DB	; <7>: 0=no handshake, 1=handshake
			; <6>: 0=software/1=hardware handshake
			; <5>: not used
			; <4>: not used
			; <3>: 0=odd parity, 1=even parity
			; <2>: 0=no parity, 1=parity as specified
			;      by bit <3>
			; <1:0> : baud rate
			;	00 =  19200
			;	01 =  38400
			;	10 =  57600
			;	11 = 115200
			
splin4		.DB	; <7>: /DSR line level
			; <6>: /CTS line status
			
sppause4	.DB
spout4		.DB
spstat4		.DB	; staus
			; <7>: rx error (data discarded)
			; <6>: rx buffer overflow
			; <5>: remote disconnession (/DSR line = 1)
			; <4>: output buffer overflow
			; <3>: break
			; <2>: framing error
			; <1>: parity error
			; <0>: overrun error

sptmp4		.DB

ibuftail4	.DW
ibufhead4	.DW
obuftail4	.DW
obufhead4	.DW
ibufcnt4	.DW
obufcnt4	.DW
icntmin4	.DW
icntmax4	.DW

spcnt4		.DB
uartlsr		.DB
uartiir		.DB

usb0name	.DS	36

	.ENDS

.LIST off
